<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>userDetail</title>
    <!-- Nhúng thư viện bootstrap -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron w-50">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3>User Detail</h3>
                <a id="inp-id"></a>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Name: </label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">User Name: </label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-user-name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Email: </label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-email" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Address: </label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="suite">Suite: </label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" id="inp-suite" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="street">Street: </label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" id="inp-street" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="city">City: </label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" id="inp-city" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="zipcode">Zipcode: </label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" id="inp-zipcode" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="geo">Geo: </label>
                    </div>
                    <div class="col-sm-10">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lat">Lat: </label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lat" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lng">Lng: </label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lng" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Phone: </label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-phone" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Website: </label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-website" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Company: </label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="companyName">Name: </label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="inp-company-name" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="catchPhrase">Catch Phrase: </label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="inp-catch-phrase" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="bs">Bs: </label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="inp-bs" class="form-control">
                    </div>
                </div>
            </div>

        </div>
        <div class="row form-group">
            <div class="col-sm-12" style="text-align: right;">
                <button class="btn btn-success w-25" id="btn-update">Cập nhật</button>
                <button id="btn-back" class="btn btn-success w-25">Quay lại</button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gUSERID;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $("#btn-back").on("click", function () {
        const V_HOME_URL = "task35.10.html";
        window.location.href = V_HOME_URL;
    });
    $("#btn-update").on("click", onBtnUpdateClick);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        var vUrlString = window.location.href;
        console.log(vUrlString);
        var vUrl = new URL(vUrlString);
        gUSERID = vUrl.searchParams.get("id");
        //console.log("ID: " + gUSERID);
        var vValid = checkValidData(gUSERID);
        
        if(vValid){
            $.ajax({
                url: "https://jsonplaceholder.typicode.com/users" + "/" + gUSERID,
                type: "GET",
                dataType: "json",
                success: function(paramResponse){
                    console.log(paramResponse);
                    showDataUaserOnForm(paramResponse);
                },
                error: function(ajaxContext){
                    alert(ajaxContext.responseText);
                }
            });
        };
    }
    function onBtnUpdateClick(){
        var vObjUser ={
            id:"",
            name:"",
            userName:"",
            email:"",
            address: {
                street:"",
                suite:"",
                city:"",
                zipcode:"",
                geo: {
                    lat:"",
                    lng:""
                }
            },
            phone:"",
            website:"",
            company: {
                name:"",
                catchPhrase:"",
                bs:"",
            }
        };
        getDataUserOForm(vObjUser);
        console.log(vObjUser);
        var vValid = checkDataUpdate(vObjUser);
        if(vValid){
            var vXmlHttp = new XMLHttpRequest();
            callApiUpdateUser(vXmlHttp,vObjUser);
            vXmlHttp.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(this.responseText);
            }
        }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function checkValidData(paramId){
        if(paramId === "" || paramId === null){
            alert("Không có ID");
            return false;
        }
        return true;
    }
    function showDataUaserOnForm(paramDataUser){
        $("#inp-id").html("ID: " + paramDataUser.id);
        $("#inp-name").val(paramDataUser.name);
        $("#inp-user-name").val(paramDataUser.username);
        $("#inp-email").val(paramDataUser.email);
        $("#inp-suite").val(paramDataUser.address.suite);
        $("#inp-street").val(paramDataUser.address.street);
        $("#inp-city").val(paramDataUser.address.city);
        $("#inp-zipcode").val(paramDataUser.address.zipcode);
        $("#inp-lat").val(paramDataUser.address.geo.lat);
        $("#inp-lng").val(paramDataUser.address.geo.lng);
        $("#inp-phone").val(paramDataUser.phone);
        $("#inp-website").val(paramDataUser.website);
        $("#inp-company-name").val(paramDataUser.company.name);
        $("#inp-catch-phrase").val(paramDataUser.company.catchPhrase);
        $("#inp-bs").val(paramDataUser.company.bs);
    }

    function getDataUserOForm(paramDataUser){
        paramDataUser.id = $("#inp-id").html();
        paramDataUser.name = $("#inp-name").val();
        paramDataUser.userName = $("#inp-user-name").val();
        paramDataUser.email = $("#inp-email").val();
        paramDataUser.address.suite = $("#inp-suite").val();
        paramDataUser.address.street = $("#inp-street").val();
        paramDataUser.address.city = $("#inp-city").val();
        paramDataUser.address.zipcode = $("#inp-zipcode").val();
        paramDataUser.address.geo.lat = $("#inp-lat").val();
        paramDataUser.address.geo.lng = $("#inp-lng").val();
        paramDataUser.phone = $("#inp-phone").val();
        paramDataUser.website = $("#inp-website").val();
        paramDataUser.company.name = $("#inp-company-name").val();
        paramDataUser.company.catchPhrase = $("#inp-catch-phrase").val();
        paramDataUser.company.bs = $("#inp-bs").val();
    }

    function checkDataUpdate(paramDataUser){
        if(paramDataUser.name == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.name == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.userName == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.email == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.suite == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.street == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.city == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.zipcode == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.geo.lat == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.address.geo.lng == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.phone == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.website == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.company.name == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.company.catchPhrase == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        if(paramDataUser.company.bs == ""){
            alert("Điền tất cả các ô");
            return false;
        }
        return true;
    }
    function callApiUpdateUser(paramXmlHttp, paramDataUser){
        paramXmlHttp.open("PUT","https://jsonplaceholder.typicode.com/users" + "/" + paramDataUser.id);
        paramXmlHttp.setRequestHeader("Content-Type","application/json;charset=UTF-8");
        paramXmlHttp.send(JSON.stringify(paramDataUser));
        
    }
</script>

</html>